<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 8rem">
        <!-- Regresar a lista de materiales  -->
        <ReturnButton
          v-if="!idEdit"
          v-on:clickEvent="verifyModal"
          title="Ir a Materiales"
          :offsetArrow="20"
          :spanTitle="3"
          class="text-end"
        ></ReturnButton>
        <ReturnButton
          v-else
          v-on:clickEvent="verifyEditModal"
          title="Ir a Materiales"
          :offsetArrow="20"
          :spanTitle="3"
          class="text-end"
        ></ReturnButton>

        <!-- Modal botón regresar -->
        <AppModalReturn
          :show-dialog.sync="returnButtonModal"
          v-if="returnButtonModal"
          v-on:btnEvent="returnButtonModal = false"
          @btnEvent="viewListMaterials"
          v-on:eventBtn="returnButtonModal = false"
        ></AppModalReturn>
        <el-col :span="24" style="padding-top: 1.5rem">
          <el-card
            :body-style="{ padding: '10px' }"
            v-if="idEdit"
            shadow="never"
            class="bg-form text-white title-views"
            >EDITAR MATERIAL</el-card
          >
          <el-card
            v-else
            :body-style="{ padding: '10px' }"
            shadow="never"
            class="bg-form text-white title-views"
            >NUEVO MATERIAL</el-card
          >
        </el-col>
      </el-header>
      <el-main style="margin: 3rem 8rem">
        <el-form :rules="rules" ref="form" :model="validateForm">
          <!-- Títulos del Material -->
          <h4 class="text-orange" style="margin-bottom: 2rem">
            TÍTULOS DEL MATERIAL
          </h4>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Título Original:"
                prop="originalTitle"
                class="inputTitleMat"
              >
                <el-input
                  v-if="idEdit"
                  v-model="materialEdit.originalTitle"
                  size="small"
                  @keyup.enter.native="addTitles"
                  show-word-limit
                  maxlength="60"
                ></el-input>
                <el-input
                  v-else
                  v-model="form.originalTitle"
                  size="small"
                  @keyup.enter.native="addTitles"
                  show-word-limit
                  maxlength="60"
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Título Español y/o Sugerido:"
                prop="ownTitle"
                class="inputTitleMat"
              >
                <el-input
                  v-if="idEdit"
                  v-model="materialEdit.ownTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
                <el-input
                  v-else
                  v-model="form.ownTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Título Comercial:"
                prop="listTitle"
                class="inputTitleMat"
              >
                <el-input
                  v-if="idEdit"
                  v-model="materialEdit.listTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
                <el-input
                  v-else
                  v-model="form.listTitle"
                  size="small"
                  show-word-limit
                  maxlength="60"
                ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top: 2.5rem" />
          <!-- Duración -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            DURACIÓN DEL MATERIAL
          </h4>
          <el-row v-if="idEdit">
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="hoursMaterial">
                <el-input
                  size="small"
                  v-model="materialEdit.hoursMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  @keyup.enter.native="$refs.jump1.focus"
                  maxlength="2"
                >
                  <template slot="append">hr</template>
                </el-input>
              </el-form-item>
            </el-col>
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="minutesMaterial">
                <el-input
                  size="small"
                  v-model="materialEdit.minutesMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  ref="jump1"
                  maxlength="2"
                >
                  <template slot="append">min</template>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row v-else>
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="hoursMaterial">
                <el-input
                  size="small"
                  v-model="form.hoursMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  @keyup.enter.native="$refs.jump1.focus"
                  maxlength="2"
                >
                  <template slot="append">hr</template>
                </el-input>
              </el-form-item>
            </el-col>
            <el-col :span="3" :offset="1">
              <el-form-item style="margin: 0" prop="minutesMaterial">
                <el-input
                  size="small"
                  v-model="form.minutesMaterial"
                  placeholder="00"
                  v-on:keypress.native="isNumber"
                  ref="jump1"
                  maxlength="2"
                >
                  <template slot="append">min</template>
                </el-input>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top: 2.5rem" />
          <!-- Capítulos y temporadas -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            CAPÍTULOS DEL MATERIAL
          </h4>
          <p class="text-reference">
            *Solo llenar si el material contiene capítulos
          </p>
          <div v-if="!idEdit">
            <el-row
              v-for="(item, index) in form.numChapters"
              :key="index"
              style="margin-bottom: 0.5rem"
            >
              <!-- <el-col :span="12" class="bg-gray" style="padding: 5px 0">
                <el-col :span="7" class="text-center" style="margin-top: 0.5rem">Temporada:</el-col>
                <el-col :span="3">
                  <el-input v-model="item.season" size="small" v-on:keypress.native="isNumber"></el-input>
                </el-col>
                <el-col
                  :span="8"
                  :offset="1"
                  class="text-center"
                  style="margin-top: 0.5rem"
                >N° de Capítulos:</el-col>
                <el-col :span="3">
                  <el-input v-model="item.chapters" size="small" v-on:keypress.native="isNumber"></el-input>
                </el-col>
              </el-col>-->
              <ChapterComponent
                :item="item"
                @verificate="verificarInformacion"
                @changeTotalCaps="changeTotalCaps"
                @changeCap="changeCap"
              />
            </el-row>
          </div>
          <div v-else>
            <el-row
              v-for="(item, index) in numChaptersEdit"
              :key="index"
              style="margin-bottom: 0.5rem"
            >
              <!-- <el-col :span="12" class="bg-gray" style="padding: 5px 0">
                <el-col :span="7" class="text-center" style="margin-top: 0.5rem">Temporada:</el-col>
                <el-col :span="3">
                  <el-input v-model="item.season" size="small" v-on:keypress.native="isNumber"></el-input>
                </el-col>
                <el-col
                  :span="8"
                  :offset="1"
                  class="text-center"
                  style="margin-top: 0.5rem"
                >N° de Capítulos:</el-col>
                <el-col :span="3">
                  <el-input
                    v-model="item.chapters"
                    @change="verificarInformacion(item, $event)"
                    size="small"
                    v-on:keypress.native="isNumber"
                  ></el-input>
                </el-col>
              </el-col>-->
              <ChapterComponent
                :item="item"
                @verificate="verificarInformacion"
                @changeTotalCaps="changeTotalCaps"
                @changeCap="changeCap"
              />
            </el-row>
          </div>

          <hr style="margin-top: 2.5rem" />
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            CARACTERÍSTICAS DEL MATERIAL
          </h4>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Tipo de Material:"
                prop="materialType"
                class="selectElMat"
              >
                <div v-if="materialEdit.canned == true">
                  <el-input
                    v-model="materialEdit.stringMaterialType"
                    size="small"
                    :disabled="true"
                  ></el-input>
                </div>
                <div v-else :span="7">
                  <el-cascader
                    v-if="idEdit"
                    style="width: 100%"
                    expand-trigger="hover"
                    size="small"
                    :options="optionsMat"
                    v-model="materialEdit.materialType"
                    @change="handleChangeMat"
                  ></el-cascader>
                  <el-cascader
                    v-else
                    size="small"
                    style="width: 100%"
                    expand-trigger="hover"
                    :options="optionsMat"
                    v-model="form.materialType"
                    @change="handleChangeMat"
                  ></el-cascader>
                </div>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Tipo de Contenido:"
                prop="typeOfContent"
                class="selectElMat"
              >
                <el-select
                  v-if="idEdit"
                  @change="generateCodeTypeCont(materialEdit.typeOfContent)"
                  v-model="materialEdit.typeOfContent"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="typeOfContent in optionsTypeOfContent"
                    :key="typeOfContent._id"
                    :label="typeOfContent.label"
                    :value="typeOfContent.label"
                  ></el-option>
                </el-select>
                <el-select
                  v-else
                  @change="generateCodeTypeCont(form.typeOfContent)"
                  v-model="form.typeOfContent"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="mtypeOfContent in optionsTypeOfContent"
                    :key="mtypeOfContent._id"
                    :label="mtypeOfContent.label"
                    :value="mtypeOfContent.label"
                  ></el-option>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="8" :offset="1">
              <el-form-item
                label="Centro de Costo:"
                prop="costCenter"
                class="selectElMat"
              >
                <el-autocomplete
                  v-if="idEdit"
                  placeholder="codigo"
                  v-model.trim="materialEdit.costCenter"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchCodeCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.code }}</div>
                  </template>
                </el-autocomplete>
                <el-autocomplete
                  v-else
                  placeholder="codigo"
                  v-model="form.costCenter"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchCodeCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.code }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
            <el-col :span="10">
              <el-form-item prop="costCenterName">
                <el-autocomplete
                  v-if="idEdit"
                  placeholder="Buscar por nombre"
                  v-model="materialEdit.costCenterName"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchNameCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.name }}</div>
                  </template>
                </el-autocomplete>
                <el-autocomplete
                  v-else
                  placeholder="Buscar por nombre"
                  v-model="form.costCenterName"
                  style="width: 100%"
                  size="small"
                  :fetch-suggestions="querySearchNameCostCenter"
                  :trigger-on-focus="false"
                  @select="handleSelectCostCenter"
                >
                  <template slot-scope="props">
                    <div>{{ props.item.name }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item label="Género:" prop="genre" class="selectElMat">
                <!-- <el-select
                  v-if="idEdit"
                  v-model="materialEdit.genre"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="genre in optionsGenre"
                    :key="genre"
                    :label="genre"
                    :value="genre"
                  ></el-option>
                </el-select>-->
                <!-- <el-select
                  v-else
                  v-model="form.genre"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="genre in optionsGenre"
                    :key="genre"
                    :label="genre"
                    :value="genre"
                  ></el-option>
                </el-select>-->
                <!-- NUEVO SELECT -->
                <el-select
                  v-if="idEdit"
                  v-model="materialEdit.genre"
                  multiple
                  collapse-tags
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%;"
                >
                  <el-option
                    style="text-transform: capitalize;"
                    v-for="(genre,index) in genders"
                    :key="index"
                    :label="genre.name"
                    :value="genre.code"
                  ></el-option>
                </el-select>

                <el-select
                  v-else
                  v-model="form.genre"
                  multiple
                  collapse-tags
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%;"
                >
                  <el-option
                    style="text-transform: capitalize;"
                    v-for="(genre,index) in genders"
                    :key="index"
                    :label="genre.name"
                    :value="genre.code"
                  ></el-option>
                </el-select>
                <!-- NUEVO SELECT -->
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item
                label="Clasificación:"
                prop="classification"
                class="selectElMat"
              >
                <el-select
                  v-if="idEdit"
                  v-model="materialEdit.classification"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="classification in optionsClassif"
                    :key="classification"
                    :label="classification"
                    :value="classification"
                  ></el-option>
                </el-select>
                <el-select
                  v-else
                  v-model="form.classification"
                  placeholder="Seleccionar"
                  size="small"
                  style="width: 100%"
                >
                  <el-option
                    v-for="classification in optionsClassif"
                    :key="classification"
                    :label="classification"
                    :value="classification"
                  ></el-option>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>

          <hr style="margin-top: 2.5rem" />
          <!-- Sección de Canal de transmisión -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">
            CANAL DE TRANSMISIÓN
          </h4>
          <el-row style="margin-bottom: 1rem">
            <el-col :span="6" :offset="1">
              <el-checkbox-group
                v-if="idEdit"
                v-model="materialEdit.checkedChanels"
                @change="gettingChannels"
              >
                <el-checkbox
                  v-for="channel in channels"
                  :label="channel"
                  :key="channel"
                  style="display: block; margin: 1rem 0 2rem 0"
                >
                  <div>{{ channel }}</div>
                </el-checkbox>
              </el-checkbox-group>
              <el-checkbox-group
                v-else
                v-model="form.checkedChannels"
                @change="gettingChannels"
              >
                <el-checkbox
                  v-for="channel in channels"
                  :label="channel"
                  :key="channel"
                  style="display: block; margin: 1rem 0 2rem 0"
                >
                  <div>{{ channel }}</div>
                </el-checkbox>
              </el-checkbox-group>
            </el-col>
          </el-row>

          <hr style="margin-top: 2.5rem" />
          <!-- Señales -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
          <el-row style="margin-bottom: 1rem">
            <el-col :span="6" :offset="1">
              <el-checkbox
                :indeterminate="isIndeterminate"
                v-model="checkAll"
                @change="handleCheckAllChange"
                border
                >Todas las señales</el-checkbox
              >
            </el-col>
            <el-col :span="6">
              <el-button @click="signalModal = true">Seleccionar</el-button>
            </el-col>
            <!-- Modal -->
            <el-dialog
              :visible.sync="signalModal"
              width="40%"
              center
              :show-close="false"
              :close-on-press-escape="false"
              custom-class="dialog-orange"
            >
              <el-form-item style="margin: 0" prop="checkedSignals">
                <el-checkbox-group
                  v-if="idEdit"
                  v-model="materialEdit.checkedSignals"
                  @change="handleCheckedSignalsChange"
                  class="text-center"
                  style="margin-left: 3rem"
                >
                  <el-checkbox
                    v-for="signal in signals"
                    :label="signal"
                    :key="signal"
                    style="width: 30%; margin: 0"
                    class="text-start"
                    >{{ signal }}</el-checkbox
                  >
                </el-checkbox-group>
                <el-checkbox-group
                  v-else
                  v-model="form.checkedSignals"
                  @change="handleCheckedSignalsChange"
                  class="text-center"
                  style="margin-left: 3rem"
                >
                  <el-checkbox
                    v-for="signal in signals"
                    :label="signal"
                    :key="signal"
                    style="width: 30%; margin: 0"
                    class="text-start"
                    >{{ signal }}</el-checkbox
                  >
                </el-checkbox-group>
              </el-form-item>
              <div style="text-align: right; margin-top: 20px">
                <el-button
                  @click="signalModal = false"
                  class="text-orange border-orange"
                  >CANCELAR</el-button
                >
                <el-button @click="signalModal = false" type="primary"
                  >ACEPTAR</el-button
                >
              </div>
            </el-dialog>
          </el-row>
          <el-form-item style="margin: 0 0 6rem 2.4rem" prop="checkedSignals">
            <div class="bg-gray">
              <div
                v-if="idEdit"
                style="display: table; height: 3.5rem; padding: 10px 7px 7px"
              >
                <el-col
                  v-for="(aitem, k) in materialEdit.checkedSignals"
                  :key="k"
                  class="bg-white"
                  style="margin: 7px; padding: 1px 5px; width: 8rem"
                  >{{ aitem }}</el-col
                >
              </div>
              <div
                v-else
                style="display: table; height: 3.5rem; padding: 10px 7px 7px"
              >
                <el-col
                  v-for="(item, j) in form.checkedSignals"
                  :key="j"
                  class="bg-white"
                  style="margin: 7px; padding: 1px 5px; width: 8rem"
                  >{{ item }}</el-col
                >
              </div>
            </div>
          </el-form-item>

          <!-- Botones cancelar, actualizar e ingresar -->
          <div class="text-end">
            <el-button
              v-on:click="modalCancelButton = true"
              class="text-orange border-orange"
              >CANCELAR</el-button
            >
            <el-button
              @click="submitForm('form')"
              type="primary"
              :disabled="isDisabledToUpdate"
            >
              <span v-if="idEdit">ACTUALIZAR</span>
              <span v-else>INGRESAR</span>
            </el-button>
          </div>
          <!-- Modal botón cancelar -->
          <AppModalDanger
            :show-dialog.sync="modalCancelButton"
            v-if="modalCancelButton"
            v-on:btnEvent="viewListMaterials"
            @btnEvent="modalCancelButton = false"
            v-on:eventBtn="modalCancelButton = false"
          ></AppModalDanger>

          <AppModal
            :show-dialog.sync="modalCortesButton"
            v-if="modalCortesButton"
            nameClass="dialog-red"
            :rutImg="require(`@/assets/images/suspicious.svg`)"
            sizeImg="80px"
            textBold="¡Un momento!"
            :parrafo="`Los capítulos de este material tienen información en soporte o revisión </br> </br>¿Esta seguro que desea borrar la información <strong>${textCortesCapitulos}</strong>?`"
            @btnEvent="returnCaps()"
            @eventBtn="modalCortesButton = false"
            btn1="CANCELAR"
            btn2="ACEPTAR"
            classBtn1="border-red"
            typeBtn1="danger"
          />

          <!-- Modal botón ingresar-->
          <AppModalSuccess
            :show-dialog.sync="addMaterialModal"
            v-if="addMaterialModal"
            :styleModal="true"
            :parrafo="
              'El material <strong>' +
              form.originalTitle.toProperCase() +
              '</strong> se ha agregado a la lista. <br> Su código es <strong>' +
              this.nuevocodigoMaterial +
              '</strong> . '
            "
            btn1="Ver materiales"
            v-on:btnEvent="addMaterialModal = false"
            @btnEvent="viewListMaterials"
            btn2="Nuevo material"
            @eventBtn="newMaterialResetForm"
          />
          <!-- updateModal -->

          <AppModalSuccess
            :show-dialog.sync="updateModal"
            v-if="updateModal"
            :styleModal="true"
            :parrafo="textSuccessUpdate"
            btn1="ACEPTAR"
            v-on:btnEvent="updateModal = false"
            @btnEvent="viewListMaterials"
          ></AppModalSuccess>

          <!-- Modal formulario invalido -->
          <el-dialog
            :visible.sync="invalidForm"
            width="30%"
            center
            :show-close="false"
            custom-class="dialog-red"
          >
            <el-row>
              <el-col :span="5">
                <img
                  src="@/assets/images/alerta.svg"
                  width="80%"
                  alt="emoticon"
                />
              </el-col>
              <el-col :span="18" :offset="1">
                <p style="line-height: 22px">
                  Por favor, ingrese todos los campos requeridos.
                </p>
              </el-col>
            </el-row>
          </el-dialog>

          <AppModal
            :show-dialog.sync="returnButtonModal"
            v-if="returnButtonModal"
            nameClass="dialog-red"
            :rutImg="require(`@/assets/images/alerta.svg`)"
            sizeImg="80px"
            textBold="¡Un momento!"
            :parrafo="'Si sales del formulario la información se perderá.'"
            v-on:btnEvent="returnButtonModal = false"
            @btnEvent="viewListMaterials"
            v-on:eventBtn="returnButtonModal = false"
            btn1="SALIR"
            btn2="SEGUIR AQUÍ"
            classBtn1="border-red"
            typeBtn1="danger"
          ></AppModal>

          <!-- Modal capitulo a eliminar contiene cortes -->
          <AppModal
            :show-dialog.sync="alertHaveCuts"
            v-if="alertHaveCuts"
            nameClass="dialog-red"
            :rutImg="require(`@/assets/images/alerta.svg`)"
            sizeImg="80%"
            :parrafo="'<strong>Antes de editar los capítulos, debes modificar los cortes del material.</strong>'"
          ></AppModal>

          <!-- Modal cuando tiene que modificar los cortes antes de modificar la hora del material -->
          <el-dialog
            :visible.sync="needEditCuts"
            width="30%"
            center
            :show-close="false"
            custom-class="dialog-red"
          >
            <el-row>
              <el-col :span="6">
                <img
                  src="@/assets/images/alerta.svg"
                  width="70%"
                  alt="emoticon"
                />
              </el-col>
              <el-col :span="18">
                <p style="line-height: 22px">
                  La duración de los cortes, no puede ser
                  <span class="text-red text-bold">MAYOR</span> a la duración
                  del material.
                </p>
                <br />
                <p style="line-height: 22px">
                  Puedes modificar la duracion del
                  <span class="text-orange">MATERIAL,</span> o disminuir los
                  <span class="text-orange">CORTES</span>.
                </p>
              </el-col>
            </el-row>
          </el-dialog>
        </el-form>
      </el-main>
    </div>
  </div>
</template>

<script>
import AppModalReturn from '@/components/AppModalReturn.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import AppModal from '@/components/AppModal.vue'
import ChapterComponent from '@/components/ChapterComponent.vue'
import {
  calculateHour,
  verificatedCutsEnd,
  getTime,
  calculateRestTimeForCuts,
} from '@/utils/calculateTimePrograms.js'
import { addTimes, restTimes } from '@/utils/calculateTime.js'
import { HTTP } from '@/main.js'
import { modifyText } from '@/utils/modifyText.js'
import { mapGetters } from 'vuex'

String.prototype.toProperCase = function () {
  const re = /(^|[^A-Za-zÁÉÍÓÚÜÑáéíóúüñ])(?:([a-záéíóúüñ])|([A-ZÁÉÍÓÚÜÑ]))|([A-ZÁÉÍÓÚÜÑ]+)/gu
  return this.replace(
    re,
    (m, caracterPrevio, minuscInicial, mayuscInicial, mayuscIntermedias) => {
      const locale = ['es', 'gl', 'ca', 'pt', 'en']
      if (mayuscIntermedias) return mayuscIntermedias.toLocaleLowerCase(locale)
      return (
        caracterPrevio +
        (minuscInicial
          ? minuscInicial.toLocaleUpperCase(locale)
          : mayuscInicial)
      )
    }
  )
}
  /**
  * @vue-data {Number} optionsMat - Opcion de la categoria de materiales a elegir
  * @vue-data {Object} form - Formulario en limpio del material
  * @vue-data {Array} genders - Propiedad donde se almacena la lista de generos
  * @vue-data {Array} channels - Canales de transmision
  * @vue-data {Array} rules - Reglas con las validaciones en cada campo del formulario
  * @vue-data {Object} materialEdit - Aqui se almacenara los datos del material que se pondra en edicion
  */
export default {
  components: {
    AppModalReturn,
    ReturnButton,
    AppModalDanger,
    AppModalSuccess,
    AppModal,
    ChapterComponent,
  },
  data() {
    return {
      genders: [],
      oldText: '',
      textSuccessUpdate: '',
      channels: ['América TV', 'América Next'],
      idEdit: JSON.parse(this.$localStorage.get('materialId')),
      materialEdit: {},
      form: {
        originalTitle: '',
        ownTitle: '',
        listTitle: '',
        duration: '',
        numChapters: [
          { chapters: '', season: '', infoByChapter: [], seasonString: '' },
        ],
        genre: '',
        costCenter: '',
        costCenterName: '',
        hoursMaterial: '01',
        minutesMaterial: '00',
        classification: '',
        typeOfContent: '',
        checkedSignals: [
          'Arequipa',
          'Chiclayo',
          'Chimbote',
          'Digital',
          'Huancayo',
          'Lima',
          'Piura',
          'Pucallpa',
          'T1',
          'T2',
          'Tacna',
          'Trujillo',
          'Web',
          "Puno",
          "Cusco",
          "Ica",
          "Tarapoto",
          "Iquitos",
          "Tumbes",
          "Cajamarca",
          "Discovery Channel",
          "Canal N",
          "Televisa"
        ],
        materialType: [],
        checkedChannels: ['América TV'],
      },
      rules: {
        originalTitle: [
          {
            required: true,
            message: 'Por favor ingrese este campo',
            trigger: 'change',
          },
        ],
        ownTitle: [
          {
            required: true,
            message: 'Por favor ingrese este campo',
            trigger: 'change',
          },
        ],
        listTitle: [
          {
            required: true,
            message: 'Por favor ingrese este campo',
            trigger: 'change',
          },
        ],
        typeOfContent: [
          {
            required: true,
            message: 'Por favor seleccione un valor',
            trigger: 'change',
          },
        ],
        costCenter: [
          {
            required: true,
            message: 'Por favor seleccione un valor',
            trigger: 'change',
          },
        ],
        hoursMaterial: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        minutesMaterial: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
      },
      editMin: '',
      editHours: '',
      numChaptersEdit: [
        { chapters: '', season: '', infoByChapter: [], seasonString: '' },
      ],
      isIndeterminate: false,
      addMaterialModal: false,
      updateModal: false,
      returnButtonModal: false,
      modalCancelButton: false,
      code: '',
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      optionsMat: [
        {
          value: 'Producción Nacional',
          label: 'Producción Nacional',
        },
        {
          value: 'Fusión Gourmet',
          label: 'Fusión Gourmet',
        },
        {
          value: 'Otros',
          label: 'Otros',
        },
      ],
      stringMaterialType: '',
      nuevocodigoMaterial: '',
      nuevoCodigoGeminis: '',
      typeContentIndex: [],
      codeTypeContent: '',
      optionsCostCenter: [],
      invalidForm: false,
      contador: 0,
      prevTotalChapters: '',
      alertHaveCuts: false,
      isDisabledToUpdate: false,
      checkAll: true,
      signalModal: false,
      signals: [],
      signalsCode: '',
      signalsTable: [
        'AR',
        'CH',
        'CY',
        'DG',
        'HU',
        'LI',
        'PC',
        'PI',
        'T1',
        'T2',
        'TC',
        'TR',
        'WE',
        "PN",
        "CU",
        "IC",
        "TP",
        "IQ",
        "TB",
        "CJ",
        "DI",
        "CN",
        "TE"
      ],
      isModifyDurationMat: false,
      esNecesarioEditarLosMateriales: false,
      needEditCuts: false,
      count: 0,
      signalNext: [],
      modalCortesButton: false,
      textCortesCapitulos: '',
      originalMaterial: {},
      codeTypeInGrid: ""
    }
  },
  computed: {
    ...mapGetters([
      "listOfCannedContentType"
    ]),
    optionsTypeOfContent() {
      return this.listOfCannedContentType
    },
    verifyChangeModal() {
      const array = [
        this.materialEdit.originalTitle,
        this.materialEdit.ownTitle,
        this.materialEdit.listTitle,
        this.materialEdit.duration,
        this.materialEdit.typeOfContent,
        this.materialEdit.hoursMaterial,
        this.materialEdit.minutesMaterial,
        this.materialEdit.checkedSignals,
        this.materialEdit.duration,
        this.materialEdit.materialType,
        this.materialEdit.costCenter,
        this.materialEdit.genre,
        this.materialEdit.minutesMaterial,
        this.numChaptersEdit[0] ? this.numChaptersEdit[0].chapters : [],
        this.numChaptersEdit[0] ? this.numChaptersEdit[0].season : [],
        this.materialEdit.classification,
        this.materialEdit.checkedChanels,
        this.materialEdit.signalsCode
          ? this.materialEdit.signalsCode.length
          : 0,
      ].join()
      return array
    },
    verifyChangeHours() {
      const array = [
        this.materialEdit.hoursMaterial,
        this.materialEdit.minutesMaterial,
      ].join()
      return array
    },
    validateForm() {
      let materialId = JSON.parse(this.$localStorage.get('materialId'))
      if (materialId) {
        return this.materialEdit
      } else {
        return this.form
      }
    },
    optionsGenre() {
      let dataTables = this.$store.state.tables
      for (let i = 0; i < dataTables.length; i++) {
        if (dataTables[i].tableName === 'genre') {
          return dataTables[i].types
        }
      }
    },
    optionsClassif() {
      let dataTables = this.$store.state.tables
      for (let i = 0; i < dataTables.length; i++) {
        if (dataTables[i].tableName === 'classification') {
          return dataTables[i].types
        }
      }
    },
  },
  watch: {
    verifyChangeModal(val) {
      this.contador += 1
    },
    verifyChangeHours(val) {
      this.count += 1
      if (this.count > 1) {
        this.isModifyDurationMat = true
        let videoCutting =
          this.materialEdit.videoCutting &&
          this.materialEdit.videoCutting.length > 0
            ? this.materialEdit.videoCutting[0]
            : false
        if (videoCutting !== false) {
          this.verificandoSiLosCortesSuperanLaDuracionDelMaterial(videoCutting)
        }
      }
    },
  },
  methods: {
    /** Definir los capitulos de un material
    * @param {String} val.value - value es el valor del capitulo inicial o final
    * @param {String} val.element - element es una cadena que define si es el capitulo inicial o final
    */
    changeCap(val) {
     
      const { value, element } = val
      let editOrNew =
        this.idEdit == '' ? this.form.numChapters[0] : this.numChaptersEdit[0]
      
      if (String(value) == '0') {
        editOrNew[element] = 1
      }
      if (element == 'firstCap') {
        let valueSelect = value == '0' ? 1 : Number(value)
        let newLastCap = valueSelect + Number(editOrNew.chapters) - 1
        editOrNew.lastCap = newLastCap
      } else {
        let valueSelect = value == '0' ? 1 : Number(value)
        let newLastCap = valueSelect - Number(editOrNew.chapters) + 1
        editOrNew.firstCap = newLastCap < 0 ? 1 : newLastCap
        editOrNew.chapters =
          Number(editOrNew.lastCap) - Number(editOrNew.firstCap) + 1
      }
    },
    /**Devolver valores a su estado vacio*/
    newMaterialResetForm() {
      this.cleanAllInputs('form')
      this.isIndeterminate = false
      this.checkAll = true
      this.form.checkedSignals = [
        'Arequipa',
        'Chiclayo',
        'Chimbote',
        'Digital',
        'Huancayo',
        'Lima',
        'Piura',
        'Pucallpa',
        'T1',
        'T2',
        'Tacna',
        'Trujillo',
        'Web',
        "Puno",
        "Cusco",
        "Ica",
        "Tarapoto",
        "Iquitos",
        "Tumbes",
        "Cajamarca",
        "Discovery Channel",
        "Canal N",
        "Televisa"
      ]
      this.signalsTable = [
        'AR',
        'CH',
        'CY',
        'DG',
        'HU',
        'LI',
        'PC',
        'PI',
        'T1',
        'T2',
        'TC',
        'TR',
        'WE',
        "PN",
        "CU",
        "IC",
        "TP",
        "IQ",
        "TB",
        "CJ",
        "DI",
        "CN",
        "TE"
      ]
      this.addMaterialModal = false
    },
    returnCaps() {
      let original = JSON.parse(this.$localStorage.get('itemObjectCopy'))
      this.modalCortesButton = false
    },
    /**Trae la informacion del capitulo seleccionado*/
    verificarInformacion(value) {
      const { item, event } = value
      const informacionCapitulos = item.infoByChapter.filter(
        (info) => info.chapter > parseInt(item.chapters)
      )
      const capitulosRevAndSop = informacionCapitulos.filter(
        (cap) =>
          (cap.radio != undefined &&
            cap.radio != null &&
            cap.radio != 'pendiente') ||
          (cap.state != undefined && cap.state != null)
      )
      const numeroCapitulos = capitulosRevAndSop.map((cap) => cap.chapter)
      if (capitulosRevAndSop.length > 0) {
        if (parseInt(item.chapters) == 0)
          this.textCortesCapitulos = 'de todos los capítulos'
        else if (item.infoByChapter.length - parseInt(item.chapters) == 1)
          this.textCortesCapitulos = `del capítulo ${
            parseInt(item.chapters) + 1
          }`
        else
          this.textCortesCapitulos = `del capítulo ${
            parseInt(item.chapters) + 1
          } al ${item.infoByChapter.length}`
        this.modalCortesButton = true
      }
    },
    /**Trae los datos del centro de costo con su codigo y el nombre
    * @param {String} item - Puede ser el codigo o nombre del centro de costo
    */
    handleSelectCostCenter(item) {
      if (JSON.parse(this.$localStorage.get('materialId'))) {
        this.materialEdit.costCenterName == undefined
          ? this.$set(this.materialEdit, 'costCenterName', item.name)
          : (this.materialEdit.costCenterName = item.name)
        this.materialEdit.costCenter = item.code
      } else {
        this.form.costCenterName = item.name
        this.form.costCenter = item.code
      }
    },
    /** Trae la lista de los centros de costos filtrados por el nombre
    * @param {String} queryString - Texto del nombre que se va escribiendo
    */
    querySearchNameCostCenter(queryString, cb) {
      this.getCostCenter({ name: queryString, code: "" }).then((res) => cb(res))
    },
    /** Trae la lista de los centros de costos filtrados por el codigo
    * @param {String} queryString - Texto del codigo que se va escribiendo
    */
    querySearchCodeCostCenter(queryString, cb) {
      this.getCostCenter({ code: queryString, name:"" }).then((res) => cb(res))
      // cb(results);
    },
    createDateTimeForRol(durationMaterial) {
      const timeInsert = new Date()
      const month = String(timeInsert.getMonth() + 1)
      const transformMonth = month.length == 1 ? `0${month}` : month
      const transformTime = [
        '01',
        transformMonth,
        timeInsert.getFullYear(),
      ].join('/')
      const concatTime = transformTime + ' ' + `${durationMaterial}`
      return concatTime
    },
    /**Mofica la duracion de un material tomando en cuenta la cantidad y el tiempo de los cortes
    * @param {String} type - String que define el tip de corte
    * @param {Array} arrayCortes - cantidad de cortes de un capitulo
    */
    modificandoLaDuracionArtisticaSiTieneCortes(
      type,
      arrayCortes,
      restHour,
      newHour
    ) {
      let newDuration = restHour
      if (type == 'allChapters') {
        for (let i = 0; i < arrayCortes.cuts.length; i++) {
          if (arrayCortes.cuts[i + 1]) {
            newDuration = restTimes(newDuration, arrayCortes.cuts[i].duration)
          } else {
            newDuration = restTimes(newDuration, arrayCortes.cuts[i].duration)
          }
          // console.log(newDuration, 'newDuration')
        }
        arrayCortes.artisticDuration = newDuration
        return arrayCortes
      } else {
        arrayCortes.map((el, i, arr) => {
          for (let j = 0; j < el.cuts.length; j++) {
            if (el.cuts[j + 1]) {
              newDuration = restTimes(newDuration, el.cuts[j].duration)
            } else {
              newDuration = restTimes(newDuration, el.cuts[j].duration)
            }
          }
          el.artisticDuration = newDuration
          newDuration = restHour
        })
        return arrayCortes
      }
    },
    /**Validacion si la cantidad de cortes no superen la duracion del material
    * @param {Array} videoCutting - Lista de los cortes a validar
    */
    verificandoSiLosCortesSuperanLaDuracionDelMaterial(videoCutting) {
      let durationMat =
        this.materialEdit.hoursMaterial +
        ':' +
        this.materialEdit.minutesMaterial +
        ':00'
      if (
        (videoCutting && videoCutting.individualChapters.length > 0) ||
        (videoCutting && videoCutting.chapterRanges.length > 0) ||
        (videoCutting && videoCutting.allChapters.cuts.length > 0)
      ) {
        if (videoCutting.allChapters.cuts.length > 0) {
          if (
            videoCutting.allChapters.cuts[
              videoCutting.allChapters.cuts.length - 1
            ].end > durationMat
          ) {
            console.log('necesita editar los cortes del material 1')
            this.esNecesarioEditarLosMateriales = true
          } else {
            this.esNecesarioEditarLosMateriales = false
            console.log(
              this.esNecesarioEditarLosMateriales,
              'this.esNecesarioEditarLosMateriales FALSE'
            )
          }
        } else {
          if (videoCutting.individualChapters.length > 0) {
            videoCutting.individualChapters.map((el, i, arr) => {
              if (el.cuts[el.cuts.length - 1].end > durationMat) {
                console.log('necesita editar los cortes del material 2')
                this.esNecesarioEditarLosMateriales = true
              } else {
                this.esNecesarioEditarLosMateriales = false
                console.log(
                  this.esNecesarioEditarLosMateriales,
                  'this.esNecesarioEditarLosMateriales FALSE'
                )
              }
            })
          }
          if (videoCutting.chapterRanges.length > 0) {
            videoCutting.chapterRanges.map((el, i, arr) => {
              if (el.cuts[el.cuts.length - 1].end > durationMat) {
                // console.log('necesita editar los cortes del material 3')
                this.esNecesarioEditarLosMateriales = true
              } else {
                this.esNecesarioEditarLosMateriales = false
                // console.log(
                //   this.esNecesarioEditarLosMateriales,
                //   'this.esNecesarioEditarLosMateriales FALSE'
                // )
              }
            })
          }
        }
      }
    },
    verifyModal() {
      if (
        this.form.originalTitle ||
        this.form.ownTitle ||
        this.form.listTitle ||
        this.form.typeOfContent ||
        this.form.genre ||
        this.form.costCenter ||
        this.form.materialType.length ||
        this.form.classification
      ) {
        this.returnButtonModal = true
      } else {
        this.viewListMaterials()
      }
    },
    verifyEditModal() {
      if (this.contador > 1) {
        this.returnButtonModal = true
      } else {
        this.$router.push({ name: 'material' })
      }
    },
    /**Trae la informacion del centro de costo dependiendo del dato que se envie
    * @param {Object} filter - Envia el codigo y el nombre, dependiendo de cual este vacio es de que manera va a filtar
    */
    async getCostCenter(filter) {
      let res = await HTTP.post('orclCostCenter/filter', filter)
      return res.data
    },
    getTables() {
      let dataType = 'tables'
      this.$store.dispatch('getData', dataType)
    },
    /** Compara los datos del centro de costo dependiendo del codigo
    * @param {String} val - Codigo del centro de costo seleccionadose
    */
    generateCodeTypeCont(val) {
      const {codeTypeInGrid} =  this.optionsTypeOfContent.find((option) => option.label === val)
      this.codeTypeContent = '100'
      this.codeTypeInGrid = codeTypeInGrid
    },
    arraySignalCode(val) {
      let arrayIndex = []
      for (var x = 0; x < val.length; x++) {
        for (var y = 0; y < this.signals.length; y++) {
          if (this.signals[y] == val[x]) {
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    /** Trae los datos del material, en caso sea edicion los datos dependiendo del id, sino vacios */
    async fetchMaterial() {
      // INICIALIZA GENEROS
      const materialId = JSON.parse(this.$localStorage.get('materialId'))
      if (materialId) {
        const res = await HTTP.get('materials/' + materialId)
        this.$localStorage.set(
          'itemObjectCopy',
          JSON.stringify(res.data.material)
        )
        this.originalMaterial = JSON.parse(JSON.stringify(res.data.material))
        this.materialEdit = res.data.material
        // this.genders = this.materialEdit.genre
        this.codeTypeContent = this.materialEdit.codeTypeContent
        this.stringMaterialType = this.materialEdit.stringMaterialType
        this.previousSigns = this.materialEdit.signalsCode
        let indexNext = ''
        this.materialEdit.signalsCode.map((signal, i) => {
          if (signal == 'NX') {
            indexNext = i
          }
        })

        if (indexNext !== '') {
          // SI HAY SEÑAL AMERICA NEXT
          this.signalsCode = this.materialEdit.signalsCode.filter(
            (signal) => signal !== 'NX'
          )
          this.signalNext = ['NX']
        } else {
          // NO HAY SEÑAL AMERICA NEXT
          this.signalsCode = this.materialEdit.signalsCode
        }
        // console.log({ aa: res.data.material })
        // Transforma numChapters para acoplarse al array solicitado
        if (res.data.material.numChapters.length > 0) {
          const {
            firstCap,
            lastCap,
            chapters,
          } = res.data.material.numChapters[0]
          if (Number(chapters) > 1 && !firstCap) {
            this.$set(res.data.material.numChapters[0], 'firstCap', '1')
          }
          if (Number(chapters) > 1 && !lastCap) {
            this.$set(
              res.data.material.numChapters[0],
              'lastCap',
              String(chapters)
            )
          }
          this.numChaptersEdit = res.data.material.numChapters
        } else {
          this.numChaptersEdit = [
            {
              chapters: '',
              season: '',
              infoByChapter: [],
              seasonString: '',
              firstCap: null,
              lastCap: null,
            },
          ]
        }
        this.prevTotalChapters = this.numChaptersEdit[0].chapters

        let haveSignals = []
        this.signalsCode.forEach((e) => {
          if (e !== '') {
            haveSignals.push(e)
          }
        })
        // this.genders = this.materialEdit.genders.split(',')
        /**tiene señales */
        if (haveSignals.length > 0) {
          this.isDisabledToUpdate = false
        } else {
          this.isDisabledToUpdate = true
        }

        let conditional =
          haveSignals.length == this.signals.length ? true : false
        if (conditional == true) {
          this.isIndeterminate = false
          this.checkAll = true
        } else {
          this.isIndeterminate = true
          this.checkAll = false
        }
        // console.log({ signalsCode: this.signalsCode, haveSignals })
      }
    },
    handleChangeMat(value) {
      let array = value
      if (array.length > 1) {
      }
      let string = ''
      array.map((el, i) => {
        if (i !== array.length - 1) {
          string += el + '-'
        } else {
          string += el
        }
      })
      this.stringMaterialType = string
      // console.log(this.stringMaterialType)
    },
    /**Validacio de que solo sea numero
    * @param {Number} evt - valor que solo sea numero
    */
    isNumber(evt) {
      evt = evt ? evt : window.event
      var charCode = evt.which ? evt.which : evt.keyCode
      if (
        charCode > 31 &&
        (charCode < 48 || charCode > 57) &&
        charCode !== 46
      ) {
        evt.preventDefault()
      } else {
        return true
      }
    },
    /** Copia el titulo en los 3 campos al dar a la tecla Enter
    * @param {String} val - Texto enviado
    */
    addTitles(val) {
      if (this.form.originalTitle) {
        this.form.ownTitle = val ? this.form.originalTitle : ''
        this.form.listTitle = val ? this.form.originalTitle : ''
      } else if (this.materialEdit.originalTitle) {
        this.materialEdit.ownTitle = val ? this.materialEdit.originalTitle : ''
        this.materialEdit.listTitle = val ? this.materialEdit.originalTitle : ''
      }
    },
    /**Trae el nombre del usuario conectado en ese instante*/
    gettingUsername() {
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    deleteDuplicate(data, laschap) {
      let result = data
        .slice()
        .reverse()
        .filter(
          (v, i, a) =>
            a.findIndex(
              (t) => t.chapter === v.chapter && t.chapter <= laschap
            ) === i
        )
        .reverse()
      return result
    },
    /**Actualiza el material a los valores nuevos que se les asigne*/
    async updatedMaterial() {
      if (this.materialEdit.minutesMaterial.length === 1) {
        this.materialEdit.minutesMaterial =
          '0' + this.materialEdit.minutesMaterial
      }
      if (this.materialEdit.hoursMaterial.length === 1) {
        this.materialEdit.hoursMaterial = '0' + this.materialEdit.hoursMaterial
      }

      /**MODIFICANDO LAS PROPIEDADAES DE VIDEOCUTTING SI MODIFICA LA DURACION Y TIENE CORTES*/
      if (this.isModifyDurationMat) {
        let videoCutting = this.materialEdit.videoCutting
          ? this.materialEdit.videoCutting[0]
          : null
        let newHour =
          this.materialEdit.hoursMaterial +
          ':' +
          this.materialEdit.minutesMaterial +
          ':00'
        let restHour =
          this.materialEdit.hoursMaterial +
          ':' +
          this.materialEdit.minutesMaterial +
          ':00'
        /**ENTRA SI TIENE CORTES*/
        if (
          (videoCutting && videoCutting.individualChapters.length > 0) ||
          (videoCutting && videoCutting.chapterRanges.length > 0) ||
          (videoCutting && videoCutting.allChapters.cuts.length > 0)
        ) {
          videoCutting.artisticDuration = newHour
          if (
            videoCutting.individualChapters.length > 0 ||
            videoCutting.chapterRanges.length > 0
          ) {
            if (videoCutting.individualChapters.length > 0) {
              let newInfoIndividuals = this.modificandoLaDuracionArtisticaSiTieneCortes(
                'diferente',
                videoCutting.individualChapters,
                this.materialEdit.hoursMaterial +
                  ':' +
                  this.materialEdit.minutesMaterial +
                  ':00'
              )
              videoCutting.individualChapters = newInfoIndividuals
            }
            if (videoCutting.chapterRanges.length > 0) {
              let newInfoRanges = this.modificandoLaDuracionArtisticaSiTieneCortes(
                'diferente',
                videoCutting.chapterRanges,
                this.materialEdit.hoursMaterial +
                  ':' +
                  this.materialEdit.minutesMaterial +
                  ':00'
              )
              videoCutting.chapterRanges = newInfoRanges
            }
          }
          if (videoCutting.allChapters.cuts.length > 0) {
            let newInfoAllChapter = this.modificandoLaDuracionArtisticaSiTieneCortes(
              'allChapters',
              videoCutting.allChapters,
              this.materialEdit.hoursMaterial +
                ':' +
                this.materialEdit.minutesMaterial +
                ':00'
            )
            videoCutting.artisticDuration = newHour
            videoCutting.allChapters = newInfoAllChapter
          }
        } else {
          if (videoCutting) {
            videoCutting.artisticDuration = newHour
            videoCutting.allChapters.artisticDuration = newHour
          }
        }
      }

      /* MODIFICANDO INFOBYCHAPTER SI SE AGREGAN O ELIMINA CAPITULOS MAS CAPITULOS */
      if (this.materialEdit.numChapters.length !== 0) {
        if (this.materialEdit.numChapters[0].chapters == '') {
          this.materialEdit.numChapters = []
        } else if (
          this.materialEdit.numChapters[0].infoByChapter.length <
          Number(this.materialEdit.numChapters[0].chapters)
        ) {
          let totalCaps = []
          let objInsert = {}
          for (
            let i = Number(this.materialEdit.numChapters[0].firstCap);
            i <= Number(this.materialEdit.numChapters[0].lastCap);
            i++
          ) {
            totalCaps.push(i)
            let chapInsertados = this.materialEdit.numChapters[0].infoByChapter.map(
              (e) => e.chapter
            )
            totalCaps.map((e) => {
              if (chapInsertados.includes(e) == false) {
                objInsert = {
                  chapter: e,
                  dynamicTags: [],
                  nameCap: 'Capítulo ' + e,
                  status: false,
                  arrivalDate: '',
                  copyBackUp: '',
                  shippingMode: '',
                  support: '',
                  radio: '',
                  arrivalDateString: '',
                  colorTriangle: false,
                }
                this.materialEdit.numChapters[0].infoByChapter.push(objInsert)
              }
            })
          }
        } else if (
          Number(this.materialEdit.numChapters[0].chapters) <
          this.materialEdit.numChapters[0].infoByChapter.length
        ) {
          let laschap = this.materialEdit.numChapters[0].lastCap
          let data = this.materialEdit.numChapters[0].infoByChapter
          console.log({data, laschap})
          let response = await this.deleteDuplicate(data, laschap)
          this.materialEdit.numChapters[0].infoByChapter = data
          console.log('2')
        }
      } else {
        if (
          this.materialEdit.numChapters.length == 0 &&
          Number(this.numChaptersEdit[0].chapters) > 0
        ) {
          let objInsert = {}
          for (
            let i = Number(this.numChaptersEdit[0].firstCap);
            i <= Number(this.numChaptersEdit[0].lastCap);
            i++
          ) {
            if (this.numChaptersEdit[0].infoByChapter[i] == undefined) {
              objInsert = {
                chapter: i,
                dynamicTags: [],
                nameCap: 'Capítulo ' + i,
                status: false,
                arrivalDate: '',
                copyBackUp: '',
                shippingMode: '',
                support: '',
                radio: '',
                arrivalDateString: '',
                colorTriangle: false,
              }
              this.numChaptersEdit[0].infoByChapter.push(objInsert)
            }
          }
          this.materialEdit.numChapters = this.numChaptersEdit
        }
      }
      let haveCaps = Boolean(this.numChaptersEdit[0].chapters)
      let groupData = []
      if (haveCaps == true) {
        console.log({infoByChapter: this.materialEdit.numChapters[0].infoByChapter})
        let totalCaps = []
        let objInsert = {}
        for (
          let i = Number(this.materialEdit.numChapters[0].firstCap);
          i <= Number(this.materialEdit.numChapters[0].lastCap);
          i++
        ) {
          totalCaps.push(i)
        }
        if(this.materialEdit.numChapters.length > 0) {
          groupData = this.materialEdit.numChapters[0].infoByChapter.map(
            (e, i) => {
              const { chapter, nameCap, ...rest } = e
              return {
                chapter: Number(this.numChaptersEdit[0].firstCap) + i,
                nameCap: `Capítulo ${
                  Number(this.numChaptersEdit[0].firstCap) + i
                }`,
                ...rest,
              }
            }
          )
          let capGroupData = groupData.map((cap) => cap.chapter)
          let joinGroupData = []
          console.log({capGroupData, totalCaps})
          groupData.map((e) => {
            if(totalCaps.includes(Number(e.chapter)) == true ) {
              joinGroupData.push(e)
            }
          })
          this.materialEdit.numChapters[0].seasonString =  `Temporada ${this.materialEdit.numChapters[0].season}`
          this.materialEdit.numChapters[0].infoByChapter = joinGroupData
          console.log({joinGroupData})
        }
        this.$set(
          this.materialEdit.numChapters[0],
          'firstCap',
          Number(this.numChaptersEdit[0].firstCap)
        )
        this.$set(
          this.materialEdit.numChapters[0],
          'lastCap',
          Number(this.numChaptersEdit[0].lastCap)
        )
      }

      let beforeDurationMaterial = `${calculateHour(
        this.materialEdit.hoursMaterial
      )}:${calculateHour(this.materialEdit.minutesMaterial)}:00`
      let durationMaterialCreated = this.createDateTimeForRol(
        `${calculateHour(this.materialEdit.hoursMaterial)}:${calculateHour(
          this.materialEdit.minutesMaterial
        )}:00`
      )
      let original = JSON.parse(this.$localStorage.get('itemObjectCopy'))
      const isDifferentOriginalTitle =
        this.materialEdit.originalTitle !== original.originalTitle
      const isDifferentownTitle =
        this.materialEdit.ownTitle !== original.ownTitle
      const isDifferentlistTitle =
        this.materialEdit.listTitle !== original.listTitle
      const isDifferenthoursMaterial =
        this.materialEdit.hoursMaterial !== original.hoursMaterial
      const isDifferentminutesMaterial =
        this.materialEdit.minutesMaterial !== original.minutesMaterial
      const isDifferentChapters = this.differentChapters(
        this.materialEdit,
        original
      )
      let isDifferentypeOfContent
      if (this.materialEdit.codMaterial.includes('M')) {
        isDifferentypeOfContent =
          this.materialEdit.typeOfContent !== original.typeOfContent
      } else {
        isDifferentypeOfContent =
          original.codeTypeContent == '100'
            ? false
            : this.materialEdit.typeOfContent !== original.typeOfContent
      }

      let newSignalsEdit = this.signalsCode.concat(this.signalNext)
      let stringSignalsEdit = newSignalsEdit.join()
      let stringSignalsOriginals = original.signalsCode.join()

      const isDifferentcostCenter =
        this.materialEdit.costCenter !== original.costCenter
      const isDifferentcheckedSignals =
        stringSignalsEdit !== stringSignalsOriginals

      // EDITAR MATERIAL
      console.log('GENEROS', this.materialEdit.genre)
      // this.genders = toString(this.materialEdit.genre)

      // if (isDifferentOriginalTitle || isDifferentownTitle ||  isDifferentlistTitle || isDifferenthoursMaterial || isDifferentminutesMaterial ||  isDifferentChapters || isDifferentypeOfContent || isDifferentcostCenter || isDifferentcheckedSignals ) {
      let payload = {
        mat: [
          { propName: 'originalTitle', value: this.materialEdit.originalTitle.trim() },
          { propName: 'ownTitle', value: this.materialEdit.ownTitle.trim() },
          { propName: 'listTitle', value: this.materialEdit.listTitle.trim() },
          { propName: 'hoursMaterial', value: this.materialEdit.hoursMaterial },
          {
            propName: 'minutesMaterial',
            value: this.materialEdit.minutesMaterial,
          },
          { propName: 'genre', value: this.materialEdit.genre },
          { propName: 'costCenter', value: this.materialEdit.costCenter.trim() },
          { propName: 'numChapters', value: this.materialEdit.numChapters },
          { propName: 'typeOfContent', value: this.materialEdit.typeOfContent },
          { propName: 'codeTypeContent', value: this.codeTypeContent },
          {
            propName: 'classification',
            value: this.materialEdit.classification,
          },
          { propName: 'videoCutting', value: this.materialEdit.videoCutting },
          { propName: 'userName', value: this.userName },
          { propName: 'userEmail', value: this.userEmail },
          { propName: 'codMaterial', value: this.materialEdit.codMaterial },
          { propName: 'materialType', value: this.materialEdit.materialType },
          { propName: 'stringMaterialType', value: this.stringMaterialType },
          {
            propName: 'checkedChanels',
            value: this.materialEdit.checkedChanels,
          },
          { propName: 'canned', value: this.materialEdit.canned },
          { propName: 'validity', value: this.materialEdit.validity },
          { propName: 'geminisCode', value: this.materialEdit.geminisCode },
          {
            propName: 'durationMaterialCreated',
            value: durationMaterialCreated,
          },
          {
            propName: 'checkedSignals',
            value: this.materialEdit.checkedSignals,
          },
          {
            propName: 'signalsCode',
            value: this.signalsCode.concat(this.signalNext),
          },
          { propName: 'previousSigns', value: this.previousSigns },
          { propName: 'beforeDurationMaterial', value: beforeDurationMaterial },
          { propName: 'isModifyDurationMat', value: this.isModifyDurationMat },
          {
            propName: 'costCenterName',
            value: this.materialEdit.costCenterName.trim(),
          },
          {
            propName: 'isModificationSignals',
            value: isDifferentcheckedSignals,
          },
          {
            propName: 'codeTypeInGrid',
            value: this.codeTypeInGrid,
          }
        ],
        id: this.idEdit,
        data: this.materialEdit,
        key: 'materials',
      }
      console.log({ payload })
      this.cortesExcedentes = 0
      HTTP.patch('materials/' + payload.id, payload.mat).then((res) => {
        this.textSuccessUpdate = `El material <strong> ${this.materialEdit.originalTitle.toProperCase()} </strong> se ha se actualizado. <br> `
        if (
          res.data.cantidadCortesExcedentes &&
          res.data.cantidadCortesExcedentes > 0
        ) {
          this.textSuccessUpdate = this.textSuccessUpdate.concat(
            `Existen <strong>${res.data.cantidadCortesExcedentes}</strong> cortes que excenden el tiempo de duración.`
          )
        }
        this.$store.commit('updateTextMaterial', 'Actualizando Materiales...')
        this.updateModal = true
      })

      this.$store.dispatch('patchData', payload)
      this.$store.commit('updateTextMaterial', 'Actualizando Materiales...')
      this.updateModal = true
      // }
      // else {
      //   console.log(this.materialEdit, 'x aquii')
      //   let payload = {
      //     mat:[
      //     { propName: "genre", value: this.materialEdit.genre },
      //     { propName: "numChapters", value: this.materialEdit.numChapters },
      //     { propName: "classification", value: this.materialEdit.classification },
      //     { propName: "userName", value: this.userName},
      //     { propName: "userEmail", value: this.userEmail},
      //     { propName: "checkedChanels", value: this.materialEdit.checkedChanels },
      //     { propName: "materialType", value: this.materialEdit.materialType },
      //     { propName: "stringMaterialType", value: this.stringMaterialType  },
      //     { propName: "typeOfContent", value: this.materialEdit.typeOfContent },
      //     ],
      //     id: this.idEdit,
      //     data: this.materialEdit,
      //     key: 'materials/update'
      //   }
      //   this.$store.dispatch('patchData', payload)
      //   this.$store.commit('updateTextMaterial', 'Actualizando Materiales...')
      //   this.updateModal = true
      // }
    },
    differentChapters(materialEdit, original) {
      if (materialEdit.numChapters && materialEdit.numChapters.length > 0) {
        let actualData = materialEdit.numChapters[0].chapters
        let originalData =
          original.numChapters && original.numChapters.length > 0
            ? original.numChapters[0].chapters
            : []
        return !(Number(actualData) == Number(originalData))
      }
    },
    /**Envia los datos del formulario para actualizar un material
    * @param {String} formName - El valor del formulario para argumentar  
    */
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        let haveSignals = this.signalsCode.concat(this.signalNext)
        
        if (valid && haveSignals.length > 0) {
          if (this.idEdit) {
            if (this.esNecesarioEditarLosMateriales) {
              this.needEditCuts = true
            } else {
              this.updatedMaterial()
            }
          } else {
            this.onSubmit()
          }
        } else {
          this.invalidForm = true
          return false
        }
      })
    },
    /**Envia los datos de un material nuevo*/
    onSubmit() {
      if (this.form.minutesMaterial.length === 1) {
        this.form.minutesMaterial = '0' + this.form.minutesMaterial
      }

      if (this.form.hoursMaterial.length === 1) {
        this.form.hoursMaterial = '0' + this.form.hoursMaterial
      }

      // Creando las propiedades para videoCutting, usado en la vista CUT
      let videoCuttings = []
      this.form.numChapters.map((el, i, arr) => {
        let oneSeason = {
          season: el.season,
          chapters: el.chapters,
          applyAllChapters: false,
          artisticDuration:
            this.form.hoursMaterial + ':' + this.form.minutesMaterial + ':00', //General y no cambia
          allChapters: {
            artisticDuration:
              this.form.hoursMaterial + ':' + this.form.minutesMaterial + ':00', //Específico y cambia según el totdal de tiempo de cortes
            cuts: [],
          },
          chapterRanges: [],
          individualChapters: [],
        }

        videoCuttings.push(oneSeason)
      })

      // Si un material NO tiene capítulos
      if (
        this.form.numChapters.length === 1 &&
        this.form.numChapters[0].season === '' &&
        this.form.numChapters[0].chapters === ''
      ) {
        this.form.numChapters = []
      } else {
        let objInsert = {}
        // Se crea un objeto por capitulo
        // for(var n=0; n<this.form.numChapters.length; n++){
        for (
          let i = Number(this.form.numChapters[0].firstCap);
          i <= this.form.numChapters[0].lastCap;
          i++
        ) {
          objInsert = {
            chapter: i,
            dynamicTags: [],
            nameCap: 'Capítulo ' + i,
            status: false,
            arrivalDate: '',
            copyBackUp: '',
            shippingMode: '',
            support: '',
            radio: '',
            arrivalDateString: '',
            colorTriangle: false,
          }
          this.form.numChapters[0].infoByChapter.push(objInsert)
        }
        // }
      }

      let beforeDurationMaterial = `${calculateHour(
        this.form.hoursMaterial
      )}:${calculateHour(this.form.minutesMaterial)}:00`
      let durationMaterialCreated = this.createDateTimeForRol(
        `${calculateHour(this.form.hoursMaterial)}:${calculateHour(
          this.form.minutesMaterial
        )}:00`
      )
      // CREAR MATERIAL
      console.log('GENEROS', this.form.genre)
      // this.form.genre = toString(this.form.genre)

      let newMaterial = {
        codMaterial: null,
        originalTitle: this.form.originalTitle.trim(),
        ownTitle: this.form.ownTitle.trim(),
        listTitle: this.form.listTitle.trim(),
        minutesMaterial: this.form.minutesMaterial,
        hoursMaterial: this.form.hoursMaterial,
        numChapters: this.form.numChapters,
        typeOfContent: this.form.typeOfContent,
        codeTypeContent: this.codeTypeContent,
        genre: this.form.genre,
        costCenter: this.form.costCenter.trim(),
        costCenterName: this.form.costCenterName.trim(),
        date1: this.form.date1,
        reviewObj: {},
        classification: this.form.classification,
        canned: false,
        materialWithCuts: false,
        videoCutting: videoCuttings,
        userName: this.userName,
        userEmail: this.userEmail,
        totalSeason: this.form.numChapters.length,
        materialType: this.form.materialType,
        stringMaterialType: this.stringMaterialType,
        checkedChanels: this.form.checkedChannels,
        geminisCode: null,
        checkedSignals: this.form.checkedSignals,
        signalsCode: this.signalsCode.concat(this.signalNext),
        beforeDurationMaterial: beforeDurationMaterial,
        durationMaterialCreated: durationMaterialCreated,
        codeTypeInGrid: this.codeTypeInGrid
      }
      console.log(newMaterial, 'nuevo material')

      HTTP.post('materials', newMaterial)
        .then((res) => {
          this.nuevocodigoMaterial = res.data.newCodeMaterial
          let dataType = 'materials'
          this.$store.commit('updateTextMaterial', 'Actualizando Materiales...')
          this.addMaterialModal = true
        })
        .catch((err) => {
          console.log(err)
        })
    },
    /**METODO PARA VERIFICAR SI CONTIENE EL CANAL AMERICA NEXT, PARA QUE LUEGO SE AGREGUE COMO SEÑAL EN ORCL*/
    gettingChannels(val) {
      // METODO PARA VERIFICAR SI CONTIENE EL CANAL AMERICA NEXT, PARA QUE LUEGO SE AGREGUE COMO SEÑAL EN ORCL
      const channelCode = 'NX'
      let hasChannel = false
      const isIncluded = this.signalNext.includes(channelCode)
      val.map((channel) => {
        if (channel == 'América Next') {
          hasChannel = true
          if (!isIncluded) {
            this.signalNext.push(channelCode)
          }
        }
      })
      if (hasChannel == false) {
        if (isIncluded) {
          const indexToRemove = this.signalsCode.indexOf(channelCode)
          this.signalNext.splice(indexToRemove, 1)
        }
      }
      // console.log(this.signalNext, 'this.signalNext')
      this.validHaveSignals(this.signalsCode, this.signalNext)
    },
    cleanAllInputs(form) {
      this.$refs[form].resetFields()
      this.isIndeterminate = true
      this.form.numChapters = [{ chapters: '', season: '', infoByChapter: [] }]
      // this.getMaterial()
    },
    viewListMaterials() {
      this.$router.push({ name: 'material' })
    },
    /**Automatiza la generacion del primer capitulo y el ultimo, apareciendo los 2 imputs al asignar la cantidad de capitulos
    * @param {String} newTotalChapters - Cantidad de capitulos del material
    */
    changeTotalCaps(newTotalChapters) {
      let hasCuts = null
      let videoCuttingData = null
      if (this.idEdit == '') {
        this.$set(this.form.numChapters[0], 'firstCap', 1)
        this.$set(
          this.form.numChapters[0],
          'lastCap',
          Number(this.form.numChapters[0].firstCap) +
            Number(newTotalChapters) -
            1
        )
      } else {
        this.numChaptersEdit[0].firstCap = 1
        this.numChaptersEdit[0].lastCap =
          Number(this.numChaptersEdit[0].firstCap) +
          Number(newTotalChapters) -
          1
        hasCuts = this.materialEdit.materialWithCuts
        videoCuttingData = this.materialEdit.videoCutting[0]
        this.materialEdit.videoCutting[0].chapters = newTotalChapters
      }
      this.isDisabledToUpdate = false

      const newAllChapters = Number(newTotalChapters)
      const prevAllChapters = Number(this.prevTotalChapters)
      // Verifica 1ro si el # de capitulos es menor al anterior ingresado y si el material tiene cortes
      if (newAllChapters < prevAllChapters && hasCuts) {
        const { chapterRanges, individualChapters } = videoCuttingData
        // Verifica si los cortes ingresados al material son por rango o individuales
        if (chapterRanges.length > 0 || individualChapters.length > 0) {
          let range = []
          let individual = []
          chapterRanges.map((cut) => {
            for (
              let x = Number(cut.startChapter);
              x < Number(cut.finalChapter) + 1;
              x++
            ) {
              range.push(x)
            }
          })

          individualChapters.map((cut) => {
            individual.push(Number(cut.chapter))
          })

          // En caso tenga cortes por rango de capitulos e individuales los une en un array
          const joinArrayOfCaps = range.concat(individual).sort()

          // Verifica si alguno de los caps con cortes se van a eliminar
          let arrIncludesCap = []
          for (let r = newAllChapters + 1; r < prevAllChapters + 1; r++) {
            if (joinArrayOfCaps.includes(r)) {
              arrIncludesCap.push(r)
            }
          }
          // En caso se quiera eliminar uno de los caps con cortes, muestra el modal de advertencia y deshabilita el boton de ACTUALIZAR
          if (arrIncludesCap.length > 0) {
            this.alertHaveCuts = true
            this.isDisabledToUpdate = true
          }
        }
      }
    },
    handleCheckAllChange(val) {
      if (this.materialEdit.checkedSignals) {
        this.materialEdit.checkedSignals = val ? this.signalsTable : []
        this.isIndeterminate = false
      } else {
        this.form.checkedSignals = val ? this.signalsTable : []
        this.isIndeterminate = false
      }
      /*Generando el código de las señales seleccionadas*/
      let arrCode = []
      if (val == true) {
        let arrIndexCode = this.arraySignalCode(this.signalsTable)
        for (var r = 0; r < arrIndexCode.length; r++) {
          arrCode.push(this.signalsByCode[arrIndexCode[r]])
        }
      }

      this.signalsCode = arrCode
      this.validHaveSignals(this.signalsCode, this.signalNext)
    },
    handleCheckedSignalsChange(value) {
      let arrCode = []
      let checkedCount = value.length
      this.checkAll = checkedCount === this.signals.length
      this.isIndeterminate =
        checkedCount > 0 && checkedCount < this.signals.length
      /*Generando el código de las señales seleccionadas*/
      let arrIndexCode = this.arraySignalCode(value)
      for (var r = 0; r < arrIndexCode.length; r++) {
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.signalsCode = arrCode
      this.validHaveSignals(this.signalsCode, this.signalNext)
    },
    validHaveSignals(signalsCode, signalNext) {
      let filterSignals =
        signalsCode == '' ? [] : signalsCode.filter((e) => e !== '')
      if (
        (filterSignals && filterSignals.length > 0) ||
        (signalNext && signalNext.length > 0)
      ) {
        this.isDisabledToUpdate = false
      } else {
        this.isDisabledToUpdate = true
      }
    },
    /**Trae la lista de señales**/
    async getSignals() {
      const { data } = await HTTP.get('tables/tableName/allSignals')
      if (data) {
        const { types, description } = data.table[0]
        this.signals = types
        this.signalsTable = types
        this.signalsByCode = description
        this.signalsCode = description
      }
    },
  },
  async created() {
    this.getTables()
    await this.getSignals()
    await this.fetchMaterial()
    this.gettingUsername()
    await this.$store.dispatch('getData', 'typeMaterial')
  },
  mounted() {
    HTTP.get(`materials/list/genres`)
      .then((res) => {
        this.genders = res.data.listGenders
      })
      .catch((err) => {
        console.log(err)
      })
  },
  beforeDestroy() {
    this.numChaptersEdit = []
    this.$store.dispatch('getData', 'materials')
  },
  async beforeCreate() {
    await this.$store.dispatch('getData', 'typeMaterial')
  }
}
</script>